Security manager service
========================

Introduction
------------

This service is responsible for system security.

It will have to deliver API keys to valid Ghost services, and respond to validation
requests from other services.

Login/password are case sensitives.

Dependencies
------------

To get the go dependencies, type

```bash
go get gitlab.com/ghostbutler/tool/crypto
go get gitlab.com/ghostbutler/tool/service/keystore
go get gitlab.com/ghostbutler/tool/service/common
go get gitlab.com/ghostbutler/tool/signal
```

API key attribution
-------------------

To be able to get an API key, a service will have to record itself with security manager
by providing a login/password. According to the set given, and if it's valid, the manager
will then associate an access level to API key, and provide two API keys, one public, and
one private.

- The public key is for service rapid identification. It allows others members of the Ghost
Network to know what type of service it is given only an API key.
- The private key is secret, and will only be used to generate "one-time" key, to validate
operation executed by service:

   Use case:
   
   The scanner service want to share found mFi devices to mFi controller.
   
   1) Service will request a one use token from security manager
   2) Service receives the token
   3) Service contact the mFi controller and gives it its "one-time" API key
   4) mFi controller Service contacts security manager and ask if this key is valid
   5) If the key is valid, the security manager answer "yes it is", and auto-invalidate the
   key.
   
The authentication level is based on configuration, and levels are not static, they can be
easily added in configuration file.

Configuration file
------------------

This is a configuration file example:

```json
{
	"storeKeyLength": 64,
	"authentication": {
	  	"access": [
			{
			  	"level": "admin",
				"basic": {
					"login": "GhostButler2018Admin",
					"password": "751448f64facb9cedb36a7439f177a8a4cb85a85a7fa31c6b360b662526b1df383cbf59a789cbe719db4b0064d3ade2659caed2a5beceed0d5d59edfd7571ffc"
				}
			},
			{
			  	"level": "scanner",
			  	"basic": {
					"login": "GhostButler2018Scanner",
				  	"password": "751448f64facb9cedb36a7439f177a8a4cb85a85a7fa31c6b360b662526b1df383cbf59a789cbe719db4b0064d3ade2659caed2a5beceed0d5d59edfd7571ffc"
				}
			},
			{
				"level": "user",
			 	"basic": {
				  	"login": "GhostButler2018User",
				  	"password": "751448f64facb9cedb36a7439f177a8a4cb85a85a7fa31c6b360b662526b1df383cbf59a789cbe719db4b0064d3ade2659caed2a5beceed0d5d59edfd7571ffc"
				}
			}
		]
	}
}
```

|Configuration line|Type|Description|
|------------------|----|-----------|
|storeKeyLength|int|The length of the API keys being generated by this service (must be > 0)|
|authentication.access.level|string|This is the access level for the login/password set|
|authentication.access.basic.login|string|This is the login to be provided for login|
|authentication.access.basic.password|string|This is the password hashed with sha512 to be provided for login|


Generate password hash
----------------------

To generate password hash, use this:

```bash
echo -n "GhostButlerProject2018*" | sha512sum
```

```raw
751448f64facb9cedb36a7439f177a8a4cb85a85a7fa31c6b360b662526b1df383cbf59a789cbe719db4b0064d3ade2659caed2a5beceed0d5d59edfd7571ffc -
```

The `-n` option is important as it will remove the `\n` at the end of string, and as `\n` would changes the
hash if left.

Endpoints
---------

- POST /api/v1/securitymanager/api

  Ask for the creation of an API key.
  
  HTTP header:
    
    - Authorization: Basic base64( "login:password" )

  POST data:
  
    - `serviceName`: The service name

  Example:

```bash
  curl https://127.0.0.1:16560/api/v1/securitymanager/api \
    -X POST \
    -u "GhostButler2018Admin:GhostButlerProject2018*" \
    -d "serviceName=Test" \
    --insecure
```

  Response if success:

```json
{
  "level":"admin",
  "serviceIP":"127.0.0.1:49300",
  "serviceName":"Test",
  "publicKey":"7iVqYh5cek7Oh8F6G5nBQ6CbRS039ki-k2KqvLBGNFXXb7exxlTzMAg1JpV6Bewo",
  "privateKey":"3b3fOH1gkjzEb8gvk0_H09JaTe2jCuAQqqNJzSWQbaLHutdHJyph3wBzj7bzhiGF",
  "deliverTime":"2018-11-15T15:56:24+01:00",
  "expirationTime":"2018-11-15T15:56:39+01:00",
  "type":0,
  "duration":15000000000
}
```

  |Name|Type|Description|
  |----|----|-----------|
  |Level|string|The level of authentication|
  |serviceIP|string|Your own IP that you used to contact the security manager|
  |serviceName|string|The service name you provided into your request|
  |publicKey|string|The public key you were attributed|
  |privateKey|string|The private key you were attributed|
  |deliverTime|string|The date the key was delivered RFC3339 formatted|
  |expirationTime|string|The date the key will expire RFC3339 formatted|
  |type|int|The key type (0=APIKey, 1=OneTime)|
  |duration|int|The validity duration expressed in nanoseconds|

- POST /api/v1/securitymanager/api/once

  Request the creation of a "one-time" use API key
  
  POST data:
  
    - `publicKey`: The public key provided by security manager
    - `privateKey`: The private key provided by security manager
    
  Example:
  
```bash
curl https://127.0.0.1:16560/api/v1/securitymanager/api/once \
    -X POST \
    -d "publicKey=7iVqYh5cek7Oh8F6G5nBQ6CbRS039ki-k2KqvLBGNFXXb7exxlTzMAg1JpV6Bewo&privateKey=3b3fOH1gkjzEb8gvk0_H09JaTe2jCuAQqqNJzSWQbaLHutdHJyph3wBzj7bzhiGF" \
    --insecure
```

  Response if success:
  
```json
{
  "level": "admin",
  "serviceIP": "127.0.0.1:49300",
  "serviceName": "Test",
  "publicKey": "gbcuGBYjUFw61Hoqt_T3OCS2rV9Yjvl2SugFQL79kDl6KpeubcdWe7-09kgu9NBw",
  "type": 1
}
```

  |Name|Type|Description|
  |----|----|-----------|
  |Level|string|The level of authentication|
  |serviceIP|string|Your own IP that you used to contact the security manager|
  |serviceName|string|The service name you provided into your request|
  |publicKey|string|The public key you were attributed|
  |type|int|The key type (here it will 1=OneTime)|

- GET /api/v1/securitymanager/api

  Get public key detail (normal/one-time). If key is valid, you get a 200 OK, else 404 not found.
  
  **CAUTION**, if you're expecting a one time use key, please do check:
  
  - key type is `1`
  - service ip given by security manager `matches` the service ip asking you to do something
  
  if you are not checking these elements, else it could end up in security failure!
  
  GET data:
  
    - `publicKey`: The public key to check

  Example:

```bash
curl https://127.0.0.1:16560/api/v1/securitymanager/api?publicKey=l11CZaWDeJTEUUYmWEqCLCblYgPvVyKs6kaIJVAzcyRFmapT6ZZ_iLA5xovg9yfe --insecure
```

  Response if success (very similar to previous response but with sensitive data removed)
  
```json
{
  "level": "admin",
  "serviceIP": "127.0.0.1:49300",
  "serviceName": "Test",
  "publicKey": "7iVqYh5cek7Oh8F6G5nBQ6CbRS039ki-k2KqvLBGNFXXb7exxlTzMAg1JpV6Bewo",
  "type": 0
}
```

  |Name|Type|Description|
  |----|----|-----------|
  |Level|string|The level of authentication|
  |serviceIP|string|Your own IP that you used to contact the security manager|
  |serviceName|string|The service name you provided into your request|
  |publicKey|string|The public key you were attributed|
  |type|int|The key type (0=APIKey, 1=OneTime)|

Author
------

Ghost Butler <lucas.soares.npro@gmail.com>

https://gitlab.com/ghostbutler/service/securitymanager.git
